<?
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */

    if (empty($_REQUEST["account"]))) {
        ?>
        <html>
            <head><title>Account adjustments:  Error, no account number.</title>
                <link rel=StyleSheet href="credit.css" type="text/css">
            </head>
            <body><h1> Error, no account number.</h1>
                <p>Please tell Spencer</p>
            </body>
        </html>
        <?
        exit;
    }



	$db = pg_connect($db_connect_str);
	if (!empty($_REQUEST["add_credit"])) {

	    $success = pg_exec($db, "insert into account_credits values ('"
                                    .$_REQUEST["account"]."', "
                                    .preg_replace("/,/",'', $_REQUEST["add_credit"]).", now(), '"
                                    .dbCheck($_REQUEST["description"])."')");

	    if ($success == false) {
                ?>
                <html>
                    <head><title>Error Adding Account Credit</title>
                        <link rel=StyleSheet href="credit.css" type="text/css">
                    </head>
                    <body><h1>Error Adding Account Credit</h1>
                        <p>Please tell Spencer</p>
                    </body>
                </html>
                <?
		exit;
	    }// success == false
	}// if add_credit

	/*now obtain the balance of the account */

	$totals = pg_exec($db, "select  t1.accountname as accountname,
					t1.credit as credit,
					t2.debit as debit
				  from	(select	SUM(cr.credit) as credit,
						acc.AccountNumber as AccountNumber,
						acc.Name as AccountName
					   FROM	(account_credits cr right outer join Accounts acc on (cr.AccountNumber = acc.AccountNumber))
					  GROUP	BY acc.AccountNumber,
						   acc.Name
					) t1
					left outer join
					(select	acc.AccountNumber as AccountNumber,
						trim(acc.name) as accountname,
						(SUM(po.shippinghandling + po.othercharges)
						+SUM(pi.unitprice * pi.quantity)) as debit
					   from		PurchaseOrders po left outer join PurchaseItems pi on (pi.PurchaseID = po.id)
						right outer join
							Accounts acc on (po.accountnumber = acc.accountnumber)
					  where	po.AccountNumber = acc.AccountNumber
					    AND	(po.cancelled Is Null Or po.cancelled = 'false')
					  GROUP	BY acc.name,
						acc.AccountNumber
					) t2
					on (t1.AccountNumber = t2.AccountNumber)
				 where	t1.AccountNumber = '".$_REQUEST["account"]."'"
			 );

	$row = pg_fetch_array($totals, 0);
?>
<html><head><title><? echo($_REQUEST["account"]." (".$row["accountname"].")"); ?> Balance and Credit</title>
	<link rel=StyleSheet href="credit.css" type="text/css">
    </head>
    <body>

	<? commonHeader($_REQUEST["account"] . " (" . $row["accountname"] . ") Balance and Credit");?>

        <table border=0 width="60%">
            <tr>
        	<th align=center > Account  </th>
        	<th align=center > Balance </th>
            </tr>
	    <tr>
                <td align=center> <? echo($_REQUEST["account"]); ?></td>
                <td align=center> $<? echo(number_format(($row["credit"] - $row["debit"]), 2)); ?></td>
            </tr>
	    <tr><td colspan=4><hr></td></tr>
	    <tr>
		<td colspan=4 align=center>
		  <form action="<?echo($this_page)?>" method=post>
		    <input type="hidden" name="form" value="adjust_credit">
		    <input type="hidden" name="account" value="<?echo($_REQUEST["account"])?>">
		    <table width="100%">
		      <tr><th></th><th>Description</th><th>Amount</th></tr>
		      <tr>
			<td align=right><input type="submit" value="Add Credit"></td>
			<td align=center>
			  <textarea name="description" rows=3 cols=40>Short description.</textarea>
			</td>
			<td align=center>$<input type="text" name="add_credit"></td>
		      </tr>
		    </table>
		  </form>
		</td>
            </tr>
	    <tr>
	      <td><table border=1 cellspacing=1 cellpadding=3>
	      		<tr><td>
	      		<a href="<?echo($this_page)?>?form=browse">Return to Browsing</a>
	      		</td></tr>
		  </table>
	      </td>
	    </tr>
	    <tr><td height=30 colspan=4></td></tr>
<?
	if($list_adjustments == "true") {
?>
	    <tr><td colspan=4><a href="<?echo($this_page)?>?form=adjust_credit&account=<?echo($_REQUEST["account"])?>"><font size=-1>Hide Adjustments</font></a></td></tr>
	    <tr><td colspan=4><hr>
	      <table>
	        <caption><h3>All Adjustments</h3></caption>
	        <tr><th>Date Applied</th><th>Description</th><th>Amount</th></tr>
<?
	    $credits = pg_exec($db,
	    		       "SELECT	dateapplied,
	    				trim(description) as description,
					credit
			          FROM	account_credits
			         WHERE	AccountNumber = '".$_REQUEST["account"]."'
				 ORDER	BY dateapplied DESC"
			 );

	    for( $n = pg_numrows($credits) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($credits, $n);
		printf("<tr><td>%s</td><td>%s</td><td>$%s</td></tr>\n", $row["dateapplied"], $row["description"], number_format($row["credit"], 2));
	    }
?>
	      </table>
	    </td></tr>
<?

	} else {
?>
	    <tr><td colspan=4><a href="<?echo($this_page)?>?form=adjust_credit&account=<?echo($_REQUEST["account"])?>&list_adjustments=true"><font size=-1>List All Adjustments</font></a></td></tr>
<?
	}// else
?>
        </table>
    </body>
</html>
<?
	pg_close($db);
	exit;

?>
