<?
/* login using admin rights */
$Administrator_mode = 1;
session_start("DBDataManagement");

session_register("hasReadTheWarning");

if (empty($_SESSION["hasReadTheWarning"]) ||  $_SESSION["hasReadTheWarning"] != true) {
    if (isset($_REQUEST["warning_given"]) &&
        $_REQUEST["warning_given"] == "yes") {
	$_SESSION["hasReadTheWarning"] = true;
    } else {
	?>
<html><head><title>DATABASE WARNING</title>
	<link rel=StyleSheet href="credit.css" type="text/css">
    </head>
    <body>

    	<DIV class="head3b">DATA INTEGRITY WARNING</DIV>

	<DIV class="justified">
        Please be extra careful when changing data in the database.  If you
	delete, or change anything without care, several logical glitches in
	the credit card database schema will begin appear.
	</DIV>
	<BR>
	<DIV class="justified">
	Click on the link below if you understand the caution and understand
	in which method the integrity of the data in the database could be
	damaged.
	</DIV>

	<center>
	<a href="?warning_given=yes">I Have Been Warned</a>
	</center
    </body>
</html>
	<?
	exit;
    }
}

require("global.php");
require("connect.php");
require("library.php");
require("fixglobals.php");

session_register("sesTheTableName");
session_register("sesTheDBName");

$tableName = empty($_REQUEST["tableName"]) ? "" : $_REQUEST["tableName"];

if (trim($tableName)!="") {
    $_SESSION["sesTheTableName"]=$tableName;
    $TheTableName=$tableName;
} else {
    if (trim($_SESSION["sesTheTableName"])=="") {

	$tables=pg_query($DB, "select relname from pg_class where relkind = 'r' and relname !~ '^pga?_';");

	if (pg_num_rows($tables) > 0) {
	    $TheTableName = pg_fetch_result($tables, 0, 0);
	} else {
	    $TheTableName="";
	}

	$_SESSION["sesTheTableName"]=$TheTableName;
    } else {
	$TheTableName=$_SESSION["sesTheTableName"];
    }
}

putHeader();

if (!empty($TheTableName)) {

    $fields = queryColumns($DB, $TheTableName);
    $columns = count($fields);
} else {
    echo "<h4>No table found</h4>\n";
    exit;
}

if ($_REQUEST["action"]=="edit") {
    echo "<FORM name=frmUpdate method=POST>\n";
    echo "<input type=hidden name=action value=update>\n";
    echo "<input type=hidden name=oldOID value=".$_REQUEST["OID"].">\n";
    echo "<TABLE BORDER=1 width=100%>\n";
    echo "<tr><td COLSPAN=2 align=center><b>$TheTableName</b></td></tr>\n";

    $res=pg_query($DB, "SELECT * FROM $TheTableName WHERE oid = ".$_REQUEST["OID"]);
    $row=pg_fetch_array($res, 0);
    for ( $i = 0; $i < $columns; $i++ ) {
	echo "<TR>\n";
	echo "<TD>".$fields[$i]["col"]."</TD>\n";
	if (is_char_type($fields[$i]["typ"])) {
	    echo "<TD><textarea cols=\"30\" rows=\"5\" name=".$fields[$i]["col"]."Val >".$row[$fields[$i]["col"]]."</textarea></TD>\n";
	} else {
	    echo "<TD><input name=".$fields[$i]["col"]."Val value=\"".$row[$fields[$i]["col"]]."\"></input></TD>\n";
	}
	echo "</TR>\n";
    }
    echo "<TR>\n";
    echo "<TD COLSPAN=2 align=center><input type=submit value=Update name=submit></TD>\n";
    echo "</TR>\n";

    echo "</TABLE>\n";
    echo "</FORM>\n";

} else if ($_REQUEST["action"]=="add") {
    $col_values = "";
    for ( $i = 0; $i < $columns; $i++ ) {
	if ( is_quoted_type($fields[$i]["typ"]) ){
	    if ( empty($_REQUEST[$fields[$i]["col"]."Val"]) ) {
		$col_values .= " null ";
	    } else {
		$col_values .= "'".$_REQUEST[$fields[$i]["col"]."Val"]."'";
	    }
	} else {
	    $col_values .= $_REQUEST[$fields[$i]["col"]."Val"];
	}

	if ($i < $columns-1) $col_values .= ", ";
    }

    $res=pg_query("INSERT INTO $TheTableName VALUES($col_values)");
    if (!$res) echo pg_last_error($DB);
    else echo "<br>Record inserted: $res<br>\n";

} else if ($_REQUEST["action"]=="addForm") {
    echo "<FORM name=frmAddForm method=POST>\n";
    echo "<input type=hidden name=action value=add>\n";
    echo "<TABLE BORDER=1 width=100%>\n";
    echo "<tr><td COLSPAN=2 align=center><b>$TheTableName</b></td></tr>\n";

    for ( $i = 0; $i < $columns; $i++ ) {
	echo "<TR>\n";
	echo "<TD>".$fields[$i]["col"]."</TD>\n";
	if (is_char_type($fields[$i]["typ"])) {
	    echo "<TD><textarea cols=\"30\" rows=\"5\" name=".$fields[$i]["col"]."Val></textarea></TD>\n";
	} else {
	    echo "<TD><input name=".$fields[$i]["col"]."Val value=\"\"></input></TD>\n";
	}
	echo "</TR>\n";
    }

		
    echo "<TR>\n";
    echo "<TD COLSPAN=2 align=center><input type=submit value=Add name=submit></TD>\n";
    echo "</TR>\n";

    echo "</TABLE>\n";
    echo "</FORM>\n";

} else if ($_REQUEST["action"]=="delete") {
    //Delete selected rows
    foreach ($IdsForDelete as $IdForDelete) { 
	//Delete selected rows
	$sql="DELETE FROM $TheTableName WHERE oid = $IdForDelete";
	$res=pg_query($sql);
	if (!$res) pg_last_error();
	else echo "$IdForDelete deleted<br>\n";
    }

} else if ($_REQUEST["action"]=="search") {
    $sql="SELECT oid,* FROM $TheTableName WHERE ";
    $first_done = 0;
    for ( $i = 0; $i < $columns; $i++ ) {
	if (trim($_REQUEST[$fields[$i]["col"]."Val"])!="") {  // If search criteria selected

	    if ($first_done == 1) $sql .= " AND ";
	    else $first_done == 1;

	    if (is_quoted_type($fields[$i]["typ"])) {
		$sql .= " lower(".$fields[$i]["col"].") LIKE lower('"
                      . $_REQUEST[$fields[$i]["col"]."Val"]."%') ";
	    } else {
		$sql .= " ".$fields[$i]["col"]."=".$_REQUEST[$fields[$i]["col"]."Val"]." ";
	    }

	}
    }
    listData($sql,$columns,$fields,$TheTableName,$_REQUEST["startingAt"],$_REQUEST["numberOfRecord"],$_REQUEST["orderBy"]);
} else if ($_REQUEST["action"]=="update") {
    $sql="UPDATE $TheTableName set ";
    for ( $i = 0; $i < $columns; $i++ ) {


	if (is_quoted_type($fields[$i]["typ"])) {
	    $sql .= $fields[$i]["col"]."=";

	    if ( empty($_REQUEST[$fields[$i]["col"]."Val"]) ) {
		$sql .= " null ";
	    } else {
		$sql .= "'".$_REQUEST[$fields[$i]["col"]."Val"]."'";
	    }
	} else {
	    $sql .= $fields[$i]["col"]."=".$_REQUEST[$fields[$i]["col"]."Val"];
	}
	if ($i < $columns-1) $sql .= ", ";
    }

    $sql .= " WHERE oid=".$_REQUEST["oldOID"];
    $res=pg_query($sql);
    if (!$res) echo pg_last_error();
    else echo "<br>Record updated: $res<br>\n";

} else { //List

        if (empty($sql)) {
            $sql = empty($_REQUEST["sql"]) ? "" : $_REQUEST["sql"];
        }

	if (trim($sql)=="") {
		$sql = "SELECT oid,* FROM $TheTableName ";
	} else {
	}
	listData($sql,$columns,$fields,$TheTableName,$_REQUEST["startingAt"],$_REQUEST["numberOfRecord"],$_REQUEST["orderBy"]);
}




////////////////////////////////////////////////////////////////////////////////////////////////////
// Functions
function listData($sql,$columns,$fields,$TheTableName,$startingAt,$numberOfRecord,$orderBy)
{
    global $gNUMBEROFRECORDS;
    //numberOfRecord and startingAt controls
    if(trim($numberOfRecord)==""){
	$numberOfRecord = $gNUMBEROFRECORDS;
    }
    if(trim($startingAt)==""){
	$startingAt = 0;
    }

   //echo //"<br><br>sql=$sql,columns=$columns,fields=$fields,TheTableName=$TheTableName,startingAt=$startingAt,numberOfRecord=$numberOfRecord<br>\n";

    if (!empty($orderBy)) {
	$sql .= " ORDER BY $orderBy";
    }

    if (trim($_REQUEST["action"])=="next" OR trim($_REQUEST["action"])=="prev") {
	session_register("SqlForPrevNext");
	$sql=$_SESSION["SqlForPrevNext"];
    } else {
	session_register("SqlForPrevNext");
	$_SESSION["SqlForPrevNext"]=$sql;
    }
	
    echo "<FORM name=frmAction method=POST>\n";
    echo "<input type=hidden name=action value=\"\">\n";

    $res=pg_query($sql);
    $showNumberOfRecord=0;

    echo "Show <input type=\"text\" name=\"numberOfRecord\"> number of record starting at <input type=\"text\" name=\"startingAt\">&nbsp;<input type=\"button\" value=\"Search\" name=\"\" onclick=\"document.frmAction.submit();\"><br>\n";
    $numberOfRows = pg_num_rows($res); 	
    //echo "<br>Number Of Rows=$numberOfRows<br>\n";

    // Prev
    if ($startingAt-$numberOfRecord<0) {
	echo "Prev \n";
    } else {
	$prevStartingAt=$startingAt-$numberOfRecord;
	echo "<a href=?action=prev&startingAt=$prevStartingAt&numberOfRecord=$numberOfRecord>Prev</a> \n";
    }

    // Next
    $nextStartingAt=$startingAt+$numberOfRecord;
    if ($numberOfRows<$nextStartingAt) {
	echo "- Next\n";
    } else {
	echo "- <a href=?action=next&startingAt=$nextStartingAt&numberOfRecord=$numberOfRecord>Next</a>\n";
    }
	
    // Show record numbers on the screen
    if ($numberOfRows<$nextStartingAt) {
	echo "&nbsp;&nbsp;&nbsp;$startingAt - $numberOfRows  / $numberOfRows<br>\n";
    } else {
	echo "&nbsp;&nbsp;&nbsp;$startingAt - ".($startingAt+$numberOfRecord)." / $numberOfRows<br>\n";
    }
    echo "<TABLE BORDER=1 width=100%>\n";
    $tableColumns=$columns+2; //For Edit column
    echo "<tr><td COLSPAN=$tableColumns align=center><b>$TheTableName</b></td></tr>\n";
	
    // Delete, field names as header, add button
    echo "<TR>\n";
    echo "<TD width=\"20\" align=\"center\"><input type=\"button\" value=\"Delete\" name=\"\" onclick=\"submitDelete()\"></TD>\n";  //For checkbox column
    echo "<TD width=\"20\" align=\"center\"><input type=\"button\" value=\"Add\" name=\"\" onclick=\"submitAdd()\"></TD>\n";  //For checkbox column
    for ( $i = 0; $i < $columns; $i++ ) {
	echo "<TD align=\"center\"><a href=\"?orderBy=".$fields[$i]["col"]."\">".$fields[$i]["col"]."</a></TD>\n";
    }
    echo "<TD></TD>\n"; //For Edit column
    echo "</TR>\n";

    // Search the fields
    echo "<TR>\n";
    echo "<TD width=\"20\" align=\"center\"></TD>\n";  //For checkbox column
    echo "<TD width=\"20\" align=\"center\"><input type=\"submit\" value=\"Search\" name=\"\" onclick=\"submitSearch()\"></TD>\n";  //For checkbox column
    for ( $i = 0; $i < $columns; $i++ ) {
	echo "<TD align=center><input name=".$fields[$i]["col"]."Val value=\"\"></input></TD>\n";
    }
    echo "</TR>\n";

    if ($startingAt>0){
    	if ($startingAt<=$numberOfRows){
	    $startingAt=$startingAt-1;
	    if (!pg_result_seek ($res, $startingAt)) {
		echo "Cannot seek to row $startingAt\n\n";
		exit;
	    }
	} else {
	    echo "Row starting point($startingAt) can not  be greater than number of rows($numberOfRows)\n";
	    exit;
	}
    }

    while($row=pg_fetch_array($res) AND $showNumberOfRecord<$numberOfRecord) {
	echo "<TR>\n";
	echo "<TD align=\"center\"><input type=\"checkbox\" name=\"IdsForDelete[]\" value=\"".$row["oid"]."\"></TD>\n";
	echo "<TD><A HREF='?OID=".$row["oid"]."&action=edit'>Edit</A></TD>\n";
	for ( $i = 0; $i < $columns; $i++ ) {
	    if (trim($row[$fields[$i]["col"]])!="")	{ // if colomn is empty put a space for td border
		echo "<TD align=\"center\">".$row[$fields[$i]["col"]]."</TD>\n";
	    } else {
		echo "<TD align=\"center\"> &nbsp;</TD>\n";
	    }
	}
	echo "</TR>\n";
	$showNumberOfRecord++;
    }
    echo "</TABLE>\n";
    echo "</FORM>\n";

?>
<SCRIPT>
	function submitDelete(){
		document.frmAction.action.value="delete";
		document.frmAction.submit();
	}
	function submitAdd(){
		document.frmAction.action.value="addForm";
		document.frmAction.submit();
	}
	function submitSearch(){
		document.frmAction.action.value="search";
		document.frmAction.submit();
	}
	function submitQuery(){
		document.frmAction.sql.value=document.frmAction.sqlQueryString.value;
		document.frmAction.action.value="list";
		document.frmAction.submit();
	}
</SCRIPT>
<?
}
?>
