<?php
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */

   /** A class to help in creating pdf output of tabular content.
    * BUGS:  This is not yet well documented and is very spaggetti-like.
   */
class PDFTable {
    var $__rows__;
    var $__head__;
    var $__head_attr__;
    var $__height__;

    function PDFTable(){
	$this->__height__ = 0;
    }

    function setHeader($cols, $col_attrs) {
        $this->__head__ = $cols;
	$this->__head_attr__ = $col_attrs;
	$this->__height__ = 0;
    }

    function appendRow($values) {
	$this->__rows__[count($this->__rows__)] = $values;
    }

    function getHeight() {
	return $this->__height__;
    }

    function strmaxwordlen($input,$len) {
	$l = 0;
	$output = "";
	for ($i = 0; $i < strlen($input); $i++) {
	    $char = substr($input,$i,1);
	    if ($char != " ") { $l++; } else { $l = 0; }
	    if ($l == $len) { $l = 0; $output .= " "; }
	    $output .= $char;
	}
	return($output);
    }

    function show($__pdf__, $__xi__, $__yi__) {
	/* first show the header */
	$__yi_orig__ = $__yi__;
	$__table_info__ = array("cols" => count($this->__head__), "rows" => count($this->__rows__));

	/* first let's get the height of the rows */
	$__row__height__ = 0;
	reset($this->__head__);
        $__row_height__ = 0;
	while (list($__col__,) = each($this->__head__)) {
	    if ($__row_height__ < $this->__head_attr__[$__col__."_fontsize"]) {
		$__row_height__ = $this->__head_attr__[$__col__."_fontsize"];
	    }
	}

	/* now write the header */
	$__xpos__ = $__xi__;
	reset($this->__head__);
	while (list($__col__,) = each($this->__head__)) {
	    $__width__ = $this->__head_attr__[$__col__."_width"];
	    $__table_info__[$__col__."_width"] = $__width__;
	    $__table_info__[$__col__."_height"] = $__row_height__;
	    $__table_info__[$__col__."_x"] = $__xpos__;
	    pdf_show_boxed($__pdf__, $__col__, $__xpos__, $__yi__, $__width__, $this->__head_attr__[$__col__."_fontsize"], $this->__head_attr__[$__col__."_align"], "");
	    pdf_rect($__pdf__, $__xpos__, $__yi__ - ($this->__head_attr__[$__col__."_fontsize"])*.2, $__width__, $__row_height__);
	    pdf_stroke($__pdf__);
	    $__xpos__ += $__width__;
	}

	$__yi__ -= $__row_height__;

	/* and now show the rest of the table. */
	$__num_rows__ = count($this->__rows__);
	for ( $__nr__ = 0; $__nr__ < $__num_rows__; $__nr__++) {
	    extract($this->__rows__[$__nr__]);
	    $__xpos__ = $__xi__;

	    /* first, let's resize the row (height) if needed. */
	    $__tmp_row_height__ = $__row_height__;
	    $__tmp_xpos__ = $__xpos__;
	    reset($this->__head__);
	    while (list($__col__,$__fmt__) = each($this->__head__)) {
		$__width__ = $this->__head_attr__[$__col__."_width"];
		eval('$__colstr__[$__col__] = "'. addslashes($__fmt__) . '";');

		$__nc_last__ = 1000000; /* some big number of chars */
		while (($__nc__ = pdf_show_boxed($__pdf__,$__colstr__[$__col__], $__tmp_xpos__, $__yi__, $__width__,$__tmp_row_height__, $this->__head_attr__[$__col__."_align"],"blind")) > 1) {
		    if($__nc__ == $__nc_last__) {
			if($__first__nc_set__ == "done") {
			    break;
			} else {
			    $__colstr__[$__col__] = $this->strmaxwordlen($__colstr__[$__col__], $__width__/$this->__head_attr__[$__col__."_fontsize"]);
			    $__first__nc_set__ = "done";
			}
		    } else {
			$__tmp_row_height__ += $__row_height__;
			$__yi__ -= $__row_height__;
			$__nc_last__ = $__nc__;
		    }
		}
		$__tmp_xpos__ += $__width__;
	    }

	    reset($this->__head__);
	    while (list($__col__,$__fmt__) = each($this->__head__)) {
		$__width__ = $this->__head_attr__[$__col__."_width"];
		pdf_show_boxed($__pdf__, $__colstr__[$__col__], $__xpos__, $__yi__, $__width__, $__tmp_row_height__, $this->__head_attr__[$__col__."_align"], "");
		pdf_rect($__pdf__, $__xpos__, $__yi__ - ($this->__head_attr__[$__col__."_fontsize"])*.2, $__width__, $__tmp_row_height__);
		pdf_stroke($__pdf__);

		/* increment the cell location */
		$__xpos__ += $__width__;
	    }

	    /* now increment the row location */
	    $__yi__ -= $__row_height__;

	    /* insert a page break if necessary (if the next row is off-page). */
            if (needsPageBreak($__yi_orig__ - $__yi__ + $__row_height__)) {
                /* start two rows beneath the top. */
		pdf_restore($__pdf__);
                $__yi__ = $__yi_orig__ = gotoNextPage();
		pdf_save($__pdf__);
            }
        }

	$this->__height__ = $__yi_orig__ - $__yi__;
	return $__table_info__;
    }

}
?>
