<?
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */

   require_once('shipping_methods.php');

?>
<html><head><title>Purchase Order Information</title>
	<link rel=StyleSheet href="credit.css" type="text/css">
    </head>
    <body>

        <? commonHeader("show_order_info");?>

      <table border=1 width=50% cellspacing=0 cellpadding=3>
        <tr>
	  <td></td>
	  <th>PO_ID</th>
	  <th>Date Ordered</th>
	  <th>Account</th>
	  <th>Ordered By</th>
	  <th>Ordered From</th>
	  <th>Total</th>
	  <? $edit_mode == 1 && printf("<th></th>"); ?>
	</tr>
<?
    $db = pg_connect($db_connect_str);

    if ($edit_mode != 1) {
        printf("<tr><th>%s</th><td>%s</td><td>%s</td><td>%s (%s)</td><td>%s %s</td><td>%s</td><td>$%s</td></tr>\n",
               (empty($order["cancelled"]) ||
                $order["cancelled"]=="f"
                ? "" : "Cancelled"
               ),
               $order["id"],
               $order["ordereddate"],
               $order["accountnumber"],
               $order["accountname"],
               $order["firstname"],
               $order["lastname"],
               $order["vendor"],
               (empty($order["subtotal"])
                ? "0.00"
                : number_format($order["subtotal"], 2)
               ));
    } else {
        /* first, we'll start off by saving any changes that have been
         * requested to the general order information.
         */
        if (empty($_REQUEST["date_needed"])) {
            $d_needed = "null";
        } else {
            $d_needed = "'".$_REQUEST["date_needed"]."'";
        }

        if (isset($_REQUEST["save_order_info"]) && $_REQUEST["save_order_info"] == 1) {
            $success = pg_exec($db, "update purchaseorders
                                        set orderedbyid = ".$_REQUEST["requestor"].",
                                            accountnumber = '".dbCheck($_REQUEST["account"])."',
                                            shippinghandling = ".$_REQUEST["shippinghandling"].",
                                            othercharges = ".$_REQUEST["othercharges"].",
                                            shiptoid = ".$_REQUEST["shiptoid"].",
                                            vendorcontact = '".dbCheck($_REQUEST["vendorcontact"])."',
                                            dateneeded = ".
                                                (empty($_REQUEST["dateneeded"])
                                                 ? "null"
                                                 : "'".$_REQUEST["dateneeded"]."'"
                                                ).",
                                            shipmentdetails = '".dbCheck($_REQUEST["shipdetails"])."',
                                            quote_number = '".dbCheck($_REQUEST["quote_number"])."',
                                            shipmentmethod = '".dbCheck($_REQUEST["shipmeth"])."',
                                            vendorid = ".$_REQUEST["company"]."
                                    where   id = ".$order["id"]
                              );

            if ($success == false) {
                printf("<font color=\"red\">Error.  Could not save data.  Please tell Spencer</font>");
            } else {
                $order["orderedbyid"]   = $_REQUEST["requestor"];
                $order["accountnumber"] = $_REQUEST["account"];
                $order["vendorid"]      = $_REQUEST["company"];
                $order["subtotal"]      -= ($order["shippinghandling"] + $order["othercharges"]);
                $order["shippinghandling"] = $_REQUEST["shippinghandling"];
                $order["othercharges"]  = $_REQUEST["othercharges"];
                $order["subtotal"]     += ($order["shippinghandling"] + $order["othercharges"]);
                $order["shipmeth"]      = $_REQUEST["shipmeth"];
                $order["shiptoid"]      = $_REQUEST["shiptoid"];
                $order["vendorcontact"] = $_REQUEST["vendorcontact"];
                $order["shipdetails"]   = $_REQUEST["shipdetails"];
                $order["dateneeded"]    = $_REQUEST["dateneeded"];
                $order["quote_number"]  = $_REQUEST["quote_number"];
            } /* else */
        }/* if */

        /* allow editing of account, ordered by, and ordered from fields. */
        $personnel = pg_exec($db, "select id, trim(firstname) as firstname, trim(lastname) as lastname, trim(uniquename) as uniquename from personnel order by firstname DESC, lastname DESC");
        //$grouprooms = pg_exec($db, "select trim(phonenumber) as phonenumber,trim(roomnumber) as roomnumber from grouprooms order by roomnumber DESC");
        //$shiptoaddrs = pg_exec($db, "select id,trim(name) as name from shiptoaddresses order by name DESC");
        $accounts = pg_exec($db, "select accountnumber,trim(name) as name, (dateclosed IS NULL OR now() < dateclosed) as open from accounts order by open DESC, name DESC");
        $vendors = pg_exec($db, "select id,trim(name) as name from vendors order by name DESC");
        $shiptoaddrs = pg_exec($db, "select id,trim(name) as name from shiptoaddresses order by name DESC");

        if ($personnel != false) {
            $personnel_list = "<select name=\"requestor\">\n";
            for( $n = pg_numrows($personnel) - 1; $n >= 0; $n-- ) {
                $row = pg_fetch_array($personnel, $n);
                $personnel_list .= sprintf("<option value=\"%s\" %s>%s %s</option>\n",
                                           $row["id"],
                                           ($row["id"] == $order["orderedbyid"] ?  "selected" : ""),
                                           $row["firstname"],
                                           $row["lastname"]);
            }/*for*/
            $personnel_list .= "</select>\n";
        }/*if*/

        if ($accounts != false) {
            $accounts_list = "<select name=\"account\">\n";
            for( $n = pg_numrows($accounts) - 1; $n >= 0; $n-- ) {
                $row = pg_fetch_array($accounts, $n);
                if ( $row["accountnumber"] == $order["accountnumber"] ) {
                    $accounts_list .= sprintf("<option value=\"%s\" selected>%s (%s)%s</option>\n",
                                              $row["accountnumber"],
                                              $row["accountnumber"],
                                              $row["name"],
                                              ($row["open"] == 'f' ?  "--closed" : ""));

                    /* break out if our account is expired--don't allow
                     * changing accounts on closed accounts */
                    if ( $row["open"] == 'f' ) break;
                } else if ( $row["open"] == 't' ) {
                    $accounts_list .= sprintf("<option value=\"%s\">%s (%s)</option>\n",
                                              $row["accountnumber"],
                                              $row["accountnumber"],
                                              $row["name"]);
                }
            }/*for*/
            $accounts_list .= "</select>\n";
        }/*if*/

        if ($vendors != false) {
            $vendors_list = "<select name=\"company\">\n";
            for( $n = pg_numrows($vendors) - 1; $n >= 0; $n-- ) {
                $row = pg_fetch_array($vendors, $n);
                $vendors_list .= sprintf("<option value=\"%s\" %s>%s</option>\n",
                                         $row["id"],
                                         ($row["id"] == $order["vendorid"] ?  "selected" : ""),
                                         $row["name"]);
            }/*for*/
            $vendors_list .= "</select>\n";
        }/*if*/

        if ($shiptoaddrs != false) {
            $shiptoaddrs_list = "<select name=\"shiptoid\">\n";
            for( $n = pg_numrows($shiptoaddrs) - 1; $n >= 0; $n-- ) {
                $row = pg_fetch_array($shiptoaddrs, $n);
                $shiptoaddrs_list .= sprintf("<option value=\"%s\" %s>%s</option>\n",
                                             $row["id"],
                                             ($row["id"] == $order["shiptoid"] ?  "selected" : ""),
                                             $row["name"]);
            }/*for*/
            $shiptoaddrs_list .= "</select>\n";
        }/*if*/

        reset($shipping_methods);
        $shipping_list = "<select name=\"shipmeth\">\n";
        while (list($shipmeth,$instr) = each($shipping_methods)) {
            $shipping_list .= sprintf("<option value=\"%s\" %s>%s%s</option>",
                                      $shipmeth,
                                      ($shipmeth == $order["shipmeth"] ?  "selected" : ""),
                                      $shipmeth,
                                      (!empty($instr)? " (".$instr.")" : "") );
        }
        $shipping_list .= "</select>\n";

?>
	    <form action="<?echo($this_page)?>" method=post>
	    	<input type=hidden name="form" value="show_order_info">
	    	<input type=hidden name="id" value="<? printf($order["id"]); ?>">
	    	<input type=hidden name="edit_mode" value="1">
	    	<input type=hidden name="save_order_info" value="1">
<?
	    printf("<tr><th>%s</th><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>$%s</td>\n", (empty($order["cancelled"]) || $order["cancelled"]=="f"?"":"Cancelled"), $order["id"], $order["ordereddate"], $accounts_list, $personnel_list, $vendors_list, (empty($order["subtotal"])?"0.00":number_format($order["subtotal"], 2)));
?>
		  <td rowspan=2>
		      <input type="reset" value="Reset">
		      <input type="submit" value="Save">
		  </td>
		</tr>
		<tr>
		  <th></th>
		  <td colspan=6>
		    <table>
		      <tr><td>Quotation Number:</td>
		          <td><input name="quote_number" value="<? echo($order["quote_number"]);?>"></td>
		      </tr>
		      <tr><td>Date Needed:</td>
		          <td><input name="dateneeded" value="<? echo($order["dateneeded"]);?>"></td>
		      </tr>
		      <tr><td>Shipping and Handling:</td>
		          <td><input name="shippinghandling" value="<? echo((empty($order["shippinghandling"])?"0.00":number_format($order["shippinghandling"], 2)));?>"></td>
		      </tr>
		      <tr><td>Other Charges:</td>
		          <td><input name="othercharges" value="<? echo((empty($order["othercharges"])?"0.00":number_format($order["othercharges"], 2)));?>"></td>
		      </tr>
		      <tr><td>Ship to:</td>
		          <td><? echo($shiptoaddrs_list);?></td>
		      </tr>
		      <tr><td>Ship via:</td>
		          <td><? echo($shipping_list);?></td>
		      </tr>
		      <tr><td>Additional Shipping Details:</td>
		          <td><textarea name="shipdetails" rows=3 cols=40><? echo($order["shipdetails"]);?></textarea></td>
		      </tr>
		      <tr><td>Company Contact:</td>
		          <td><input name="vendorcontact" value="<? echo($order["vendorcontact"]);?>"></td>
		      </tr>
		    </table>
		  </td>
		</tr>
	    </form>
<?
	}

	$items = pg_exec($db, "SELECT	pi.oid as id,
					trim(pi.unit) as unit,
					trim(pi.description) as description,
					pi.quantity,
					pi.unitprice
				 FROM	PurchaseItems pi
				WHERE	pi.PurchaseID = ".$order["id"]."
			      ORDER BY	unit DESC");

	pg_close($db);
?>

         <tr><th></th><td colspan=7 align=right>
           <table width=95%>
             <tr>
	      <th>Unit</th>
	      <th>Description</th>
	      <th>Quantity</th>
	      <th nowrap>Unit Price</th>
	     </tr>

<?
	if ($items != false) {
	    if ($edit_mode == 1) {
		$edit_buttons =
			"<td>
			    <form action=\"".$this_page."\" method=\"post\">
				<input type=hidden name=\"form\" value=\"item_edit\">
			      	<input type=hidden name=\"id\" value=\"".$order["id"]."\">
			      	<input type=hidden name=\"item_id\" value=\"%s\">
			      	<input type=hidden name=\"edit_mode\" value=\"1\">
			      	<input type=hidden name=\"edit_item\" value=\"start\">
			      	<input type=submit value=\"Edit\">
			     </form>
			 </td>
			 <td>
			    <form action=\"".$this_page."\" method=\"post\">
				<input type=hidden name=\"form\" value=\"item_edit\">
			      	<input type=hidden name=\"id\" value=\"".$order["id"]."\">
			      	<input type=hidden name=\"item_id\" value=\"%s\">
			      	<input type=hidden name=\"edit_mode\" value=\"1\">
			      	<input type=submit name=\"delete_item\" value=\"Delete\">
			     </form>
			 </td>";
	    } else {
		$edit_buttons = "";
	    }

	    $fmt = "<tr><td>%s</td><td>%s</td><td>%s</td><td>$%s</td>".$edit_buttons."</tr>\n";


	    for( $n = pg_numrows($items) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($items, $n);
		printf($fmt, $row["unit"], $row["description"], $row["quantity"], number_format($row["unitprice"], 2),$row["id"],$row["id"]);
	    }/*for*/
	}/*if*/

	if ($edit_mode == 1) {
?>
	    <tr>
	      <td><table border=1 cellspacing=1 cellpadding=3>
	      		<tr><td>
	      		<a href="<?echo($this_page)?>?form=item_edit&add_item=start&id=<? printf($order["id"]); ?>&edit_mode=1">Add Item</a>
	      		</td></tr>
		  </table>
	      </td>
	      <td colspan=5></td>
	    </tr>
<?
	}

?>
          </table>
	</td></tr>
      </table><br>

      <table border=1 cellspacing=10 cellpadding=3>
	<tr>
	  <td><a href="<?echo($this_page)?>?form=show_order&id=<?print($order["id"]);?>">Download PDF</a></td>
	  <td>
	    <form action="<?echo($this_page)?>" method="post">
	      <input type=hidden name="form" value="print_order">
	      <input type=hidden name="id" value="<?print($order["id"]);?>">
	      <input type=submit value="Send to">
	      <select name="send_to_printer">
		<option value="amo">AMO Printer</option>
		<option value="sb149">SB149 HP2200dn Printer</option>
		<option value="ocs-color-ss">OCS Color Printer</option>
		<option value="ocs-bw-ss">OCS BW Printer</option>
	      </select>
	    </form>
	  </td>
	  <td>
<?
	    if ($edit_mode == 1) {
	  	printf("<a href=\"".$this_page."?form=show_order_info&id=".$order["id"]."\">Exit Edit Mode</a>");

		printf("<td><a href=\"".$this_page."?form=cancel_order&id=".$order["id"]
		  .    (empty($order["cancelled"]) || $order["cancelled"]=="f" ?
		  		"\">Cancel"	:
				"&uncancel=1\">Undelete/Uncancel")
		  .    "Purchase Order</a>");
	    } else {
	  	printf("<a href=\"".$this_page."?form=show_order_info&id=".$order["id"]."&edit_mode=1\">Edit</a>");
	    }
?>
	  </td>
      </table>

    </body>
</html>
<?
	    exit;


?>
