<?
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */
   require('common.php');

    /* the next few lines are a hack to fix problems when moving to the new
     * server. */

   if (!empty($_REQUEST["real_max_num_items"])) {
	$max_num_items = $_REQUEST["real_max_num_items"];
   }

   $id   = isset($_REQUEST["id"]) ? $_REQUEST["id"] : "";
   $form = isset($_REQUEST["form"]) ? $_REQUEST["form"] : "no_form";
   $edit_mode = isset($_REQUEST["edit_mode"]) ? $_REQUEST["edit_mode"] : 0;



    for ( $n = 0; $n < $max_num_items; $n++ ) {
        ${"qty".$n} = isset($_REQUEST["qty".$n])     ? $_REQUEST["qty".$n] : "";
        ${"unit".$n} = isset($_REQUEST["unit".$n])   ? $_REQUEST["unit".$n] : "";
        ${"desc".$n} = isset($_REQUEST["desc".$n])   ? $_REQUEST["desc".$n] : "";
        ${"price".$n} = isset($_REQUEST["price".$n]) ? $_REQUEST["price".$n] : "";
    }

   if (isset($_REQUEST["show_sample"]) &&
       $_REQUEST["show_sample"] != "") {
	$po_id = "000smpl";
        /* forward to show_order form. */
        $form = "show_order";
   } else if ($form == "finish_order" && !empty($_REQUEST["incr_max_num_items"])) {
	$max_num_items += 5;
   } else if ($form == "finish_order" && $_REQUEST["finish_submit"] == "Submit") {
       require('submit_order.php');
   } else if ($form == "show_order_info" || $form == "cancel_order") {
	$db = pg_connect($db_connect_str);

	if ($form == "cancel_order") {
	    if (empty($_REQUEST["uncancel"]) || $_REQUEST["uncancel"] != 1) {
		$retval = pg_exec($db, "update purchaseorders set cancelled = 'true' where id = ".$id);
	    } else {
		$retval = pg_exec($db, "update purchaseorders set cancelled = 'false' where id = ".$id);
	    }

            /* now  forward to the show_order_info form. */
            $form = "show_order_info";
	}

	$order_query = pg_exec($db, 	"SELECT	p.id as orderedbyid,
						trim(p.firstname) as firstname,
						trim(p.lastname) as lastname,
						v.id as vendorid,
						trim(v.name) as vendor,
						trim(a.name) as accountname,
						trim(a.accountnumber) as accountnumber,
						to_char(o.ordereddate, 'DD-Mon-YYYY') as ordereddate,
						to_char(o.dateneeded, 'DD-Mon-YYYY') as dateneeded,
						o.id as id,
						trim(o.shipmentmethod) as shipmeth,
						trim(o.shipmentdetails) as shipdetails,
						trim(o.quote_number) as quote_number,
						o.shippinghandling as shippinghandling,
						o.othercharges as othercharges,
						trim(o.vendorcontact) as vendorcontact,
						trim(o.umich_contactnumber) as umich_contactnumber,
						o.shiptoid as shiptoid,
						o.cancelled as cancelled,
						(o.shippinghandling + o.othercharges +  SUM(i.unitprice * i.quantity)) as subtotal
					   FROM	personnel p,
						vendors v,
						accounts a,
						purchaseorders o left outer join PurchaseItems i on (i.PurchaseID = o.id)
					  WHERE	o.id = ".$id."
					    AND o.accountnumber = a.accountnumber
					    AND o.vendorid = v.id
					    AND o.orderedbyid = p.id
					  GROUP	BY
					  	p.id,
					  	p.firstname,
						p.lastname,
						v.id,
						v.name,
						a.name,
						a.accountnumber,
						o.ordereddate,
						o.dateneeded,
						o.shipmentmethod,
						o.shipmentdetails,
						o.quote_number,
						o.vendorcontact,
						o.umich_contactnumber,
						o.shiptoid,
						o.id,
						o.cancelled,
						o.shippinghandling,
						o.othercharges" );

	$order = pg_fetch_array($order_query, 0);
	
	pg_close($db);

   } else if ($form == "show_order" || $form == "print_order") {
	$db = pg_connect($db_connect_str);

	$poq = pg_exec($db, "SELECT	orderedbyid,
					approvedby,
					trim(umich_contactnumber) as umich_contactnumber,
					to_char(ordereddate, 'DD-Mon-YYYY') as ordereddate,
					to_char(dateneeded, 'DD-Mon-YYYY') as dateneeded,
					accountnumber,
					trim(shipmentmethod) as shipmentmethod,
					trim(shipmentdetails) as shipmentdetails,
                                        trim(quote_number) as quote_number,
					vendorid,
					shippinghandling,
					othercharges,
					shiptoid,
					trim(vendorcontact) as vendorcontact,
					cancelled
			       FROM	PurchaseOrders
			      WHERE	id = ".$id
		      );

	if ($poq == false || pg_numrows($poq) == 0) {
?>
<html><head><title>Error Retrieving Past Purchase Order</title>
	<link rel=StyleSheet href="credit.css" type="text/css">
    </head>
    <body><h1> Error Retrieving Past Purchase Order </h1>
    	<p>Please tell Spencer</p>
    </body>
</html>
<?
	    exit;
	}

	$po = pg_fetch_array($poq, 0);
	$po_id = $id;
	$requestor = $po["orderedbyid"];
	$approved = $po["approvedby"];
	$phone = $po["umich_contactnumber"];
	$date_ordered = $po["ordereddate"];
	$date_needed = $po["dateneeded"];
	$account = $po["accountnumber"];
	$ship_method = $po["shipmentmethod"];
	$ship_method_details = $po["shipmentdetails"];
	$quote_number = $po["quote_number"];
	$company = $po["vendorid"];
	$shipping_charges = $po["shippinghandling"];
	$other_charges = $po["othercharges"];
	$shipto = $po["shiptoid"];
	$company_contact = $po["vendorcontact"];

	if ($po["cancelled"]=='t') {
	    $order_cancelled = true;
	}

	/* now go ahead and add things up and store each row value */

	$piq = pg_exec($db, "SELECT	quantity,
					unit,
					description,
					unitprice
			       FROM	PurchaseItems
			      WHERE	purchaseid = ".$id."
			      ORDER BY	unit ASC
		      ");

	$max_num_items = pg_numrows($piq);
	for ( $n = 0; $n < $max_num_items; $n++ ) {
	    $pi = pg_fetch_array($piq, $n);
	    ${"qty".$n} = $pi["quantity"];
	    ${"unit".$n} = $pi["unit"];
	    ${"desc".$n} = $pi["description"];
	    ${"price".$n} = $pi["unitprice"];
	}
	pg_close($db);

   } else if ($form == "add_company") {
        require('add_company.php');
   } else if ($form == "search") {
        require('search.php');
   } else if ($form == "browse") {
        require('browse.php');
   } else if ($form == "adjust_credit") {
        require('adjust_credit.php');
   } else if ($form == "list_orders") {
        require('list_orders.php');
   } else if ($form == "clear_po") {
        require('clear_po.php');
   } else if ($form == "item_edit" && $edit_mode == 1) {
        require('item_edit.php');
   }


    /* pick which output to give to the user.
     * NOTE:  the above forms may not return (they give their own output to
     * the user).
     */
    if ($form == "show_order_info") {
        require('show_order.php');
    } else if ($form == "show_order") {
        require('show_pdf.php');
    } else if ($form == "print_order") {
        require('print_po.php');
    } else /* $form == "order" */ {
        require('place_order.php');
    }
?>

