<?
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */

   require_once('shipping_methods.php');

	$db = pg_connect($db_connect_str);
	$personnel = pg_exec($db, "select id, trim(firstname) as firstname, trim(lastname) as lastname, trim(uniquename) as uniquename from personnel order by firstname DESC, lastname DESC");
	$grouprooms = pg_exec($db, "select trim(phonenumber) as phonenumber,trim(roomnumber) as roomnumber from grouprooms order by roomnumber DESC");
	$shiptoaddrs = pg_exec($db, "select id,trim(name) as name from shiptoaddresses order by name DESC");
	$accounts = pg_exec($db, "select accountnumber,trim(name) as name from accounts where (dateclosed IS NULL OR now() < dateclosed) order by name DESC");
	$vendors = pg_exec($db, "select id,trim(name) as name from vendors order by name DESC");
	pg_close($db);
?>
<html>
    <head>
        <title>Credit Card Order Form</title>
	<link rel=StyleSheet href="credit.css" type="text/css">
    
    </head>

    <body>

	<? commonHeader("order");?>

    <script language="JavaScript">
    <!--
        function confirm_entry() {
            if (document.poform.incr_max_num_items.value == '' && document.poform.account.value == '') {
                alert ("Please select an account");
                return false;
            }
        }

        function popup_add_item() {
            company = document.poform.company.value;
            mywindow = window.open ("add_item_popup.php?company="+company,
                                    "add_item_popup",
                                    "location=0,resizable=1,status=1,scrollbars=0,width=400,height=250");
            mywindow.moveTo(0,0);
            mywindow.focus();
        }
    -->
    </script>

    <form name="poform" action="<?echo($this_page)?>" method="post" onSubmit="return confirm_entry();">
        <input type=hidden name="form" value="finish_order">
        <table border=0 width=100% cellspacing=0 cellpadding=1>
            <tr>
                <td>
                    Name: <select name="requestor">
<?
	if ($personnel != false) {
	    for( $n = pg_numrows($personnel) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($personnel, $n);
		printf("<option value='%s' %s>%s</option>\n",
                        $row["id"],
                        (isset($_REQUEST["requestor"]) ?
                            ($_REQUEST["requestor"]    == $row["id"]         ? "selected":"")
                          : ($_SERVER["PHP_AUTH_USER"] == $row["uniquename"] ? "selected":"")
                        ),
                        ($row["firstname"]." ".$row["lastname"])
                      );
	    }
	}
?>
	                    </select>
                </td>
                <td>
                    Today's Date:&nbsp;&nbsp;<?print(date("d-M-Y"));?>
                </td>
            </tr>
            <tr>
                <td>
                    Approved by:&nbsp;&nbsp;
                    <input name="approved" size="20"
                     value="<?echo isset($_REQUEST["approved"]) ?
                                   $_REQUEST["approved"]
                                 : $dflt_approved_by;?>">
                </td>
                <td>
                    Date Needed:&nbsp;&nbsp;
                    <input name="date_needed" maxlength="11" size="20"
                     value="<?echo isset($_REQUEST["date_needed"]) ? $_REQUEST["date_needed"] : "";?>">
                </td>
            </tr>
            <tr>
                <td>
                    Phone: <select name="phone">
<?
	if ($grouprooms != false) {
	    for( $n = pg_numrows($grouprooms) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($grouprooms, $n);
		printf("<option value='%s' %s>%s</option>\n",
                       $row["phonenumber"], 
                       (isset($_REQUEST["phone"]) &&
                        $_REQUEST["phone"] == $row["phonenumber"] ? "selected":""),
                       ($row["phonenumber"]." (".$row["roomnumber"].")"));
	    }
	}
?>
                	</select>	
                </td>
                <td>
                    Account #: <select name="account">
                                 <option value=''> Please Select Account </option>
<?
	if ($accounts != false) {
	    for( $n = pg_numrows($accounts) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($accounts, $n);
		printf("<option value='%s' %s>%s</option>\n",
                       $row["accountnumber"], 
                       (isset($_REQUEST["account"]) &&
                        $_REQUEST["account"] == $row["accountnumber"] ? "selected":""),
                       ($row["accountnumber"]." (".$row["name"].")"));
	    }
	}
?>
		     </select>
                </td>
            </tr>
            <tr>
                <td>
		    Ship To Address: <select name="shipto">
<?
	if ($shiptoaddrs != false) {
	    for( $n = pg_numrows($shiptoaddrs) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($shiptoaddrs, $n);
		printf("<option value='%s' %s><pre>%s</pre></option>\n",
                       $row["id"], 
                       (isset($_REQUEST["shipto"]) &&
                        $_REQUEST["shipto"] == $row["id"] ? "selected":""),
                       $row["name"]);
	    }
	}
?>
		</select>
                </td>
		<td>&nbsp;</td>
            </tr>
            <tr>
                <td>
                    Method of Shipment: <select name="ship_method">
<?
	    reset($shipping_methods);
	    while (list($shipmeth,$instr) = each($shipping_methods)) {
		printf("<option value=\"%s\" %s>%s%s</option>", 
                       $shipmeth, 
                       (isset($_REQUEST["ship_method"]) &&
                        $_REQUEST["ship_method"] == $shipmeth ? "selected":""),
                       $shipmeth, 
                       (!empty($instr)? " (".$instr.")" : "") );
	    }
?>
                    </select>
                </td>
	        <td rowspan=2>
                    <table>
                      <tr><td>
                    Company: <select name="company">
<?
	if ($vendors != false) {
	    for( $n = pg_numrows($vendors) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($vendors, $n);
		printf("<option value='%s' %s>%s</option>\n",
                       $row["id"],
                       (isset($_REQUEST["company"]) &&
                        $_REQUEST["company"] == $row["id"] ? "selected":""),
                       $row["name"]);
	    }
	}
?>
                    </select>
                    </td></tr>
	        <!-- td>
                    <a href="<?echo($this_page)?>?form=add_company"
                    onClick='javascript: return confirm("You might have to reenter your order form.  You can add a new vendor later (using the vendor link) and change your order later...");'
                    >Click here to add new company to list</a><br>
                </td --!>

                    <tr><td>
                    Company Contact:
                    <input type="text" name="company_contact"
                    value="<? echo isset($_REQUEST["company_contact"]) ? $_REQUEST["company_contact"] : "";?>">
                    </td></tr>
                    <tr><td>
                    Quotation Number:
                    <input type="text" name="quote_number"
                    value="<? echo isset($_REQUEST["quote_number"]) ? $_REQUEST["quote_number"] : "";?>">
                    </td></tr>
                </table>
            </tr>
            <tr>
	        <td>Additional Shipping Details:&nbsp;&nbsp;<br>
                    <textarea name="ship_method_details" rows=3 cols=40><?
                        echo isset($_REQUEST["ship_method_details"]) ? $_REQUEST["ship_method_details"] : "";
                    ?></textarea>
                </td>
                <td>&nbsp;</td>
            </tr>
        </table>
        <hr>
	    <input type=submit name="add_rows" value="Add five blank rows"
                   onClick="javascript: incr_max_num_items.value='Add five blank rows';">
	    <input type=hidden name="incr_max_num_items" value="">
	<input type=hidden name="real_max_num_items" value="<?print($max_num_items)?>">
        &nbsp;
        <table border=0 width="60%">
            <tr>
        	<th align=center > Qty  </th>
        	<th align=center > Unit </th>
        	<th align=center > Description </th>
        	<th align=center > Unit Price </th>
            </tr>
<?
	for ( $n = 0; $n < $max_num_items; $n++ ) {
	    print("
            <tr>
                <td align=center> <input name=qty".$n." size=10% value = \""
                    .(empty(${"qty".$n}) ? "" : ${"qty".$n})
                    ."\">  </td>
                <td align=center> <input name=unit".$n." size=20% value = \""
                    .(empty(${"unit".$n}) ? "" : ${"unit".$n})
                    ."\"> </td>
                <td align=center> <input name=desc".$n." size=40% value = \""
                    .(empty(${"desc".$n}) ? "" : ${"desc".$n})
                    ."\"> </td>
                <td align=center nowrap> $<input name=price".$n." size=10% value = \""
                    .(empty(${"price".$n}) ? "" : ${"price".$n})
                    ."\"> </td>
            </tr>\n" );
	}
?>
            <tr><td colspan=4 align=center>
                <input type="button"
                       value="                    Add Item From Company                    "
                       onClick="javascript:popup_add_item();"
                >
            </td></tr>
	    <tr><td colspan=4><hr></td></tr>
        </table> 
	<table>
	  <tr>
	    <td align="right"> Shipping and Handling: </td>
	    <td align="left" colspan=2>
                $<input type="text" name="shipping_charges"
                  value="<?echo isset($_REQUEST["shipping_charges"]) ? $_REQUEST["shipping_charges"] : "";?>">
            </td>
	  </tr>
	  <tr>
	    <td align="right"> Other Charges:</td>
	    <td align="left" colspan=2>
                $<input type="text" name="other_charges"
                  value="<?echo isset($_REQUEST["other_charges"]) ?  $_REQUEST["other_charges"] : "";?>">
            </td>
	  </tr>
	</table>
	<hr>

        <p>
        <input type="reset" value="Reset" onClick='javascript:return confirm("Do you really want to clear everything?");'>
        <input type="submit" name="show_sample" value="Review Order">
        <input type="submit" name="finish_submit" value="Submit">
	</p>
	<p><font color="blue">Submit will record the order in the database.</font>
    </form>
    </body>
</html>

